## magma 2.9.0%2Bds

=== debian/changelog ===
magma (2.9.0+ds-2) unstable; urgency=medium

  [ Cordell Bloor ]
  * Add magma-rocm packages.
  * d/{rules,rocmbuild.sh}: fix libmagma-rocm-test multiarch directory
  * Add libmagma-rocm-doc package
  * d/control*: update Standards-Version to 4.7.0
  * d/control*: update debhelper-compat to 13
  * d/rules: drop sparse_hip/testing from libmagma-rocm-test
  * Add d/p/static-test-libs.patch
  * Register magma docs with doc-base.

  [ Mo Zhou ]
  * [ROCm] Add missing build-dep cmake.
  * [ROCm] Update lintian overrides.
  * [ROCm] Add Breaks+Replaces against the CUDA version.
  * Add Breaks+Replaces against the ROCm variant.
  * Patch upstream test runner.
  * d/rules: Should use DEB_HOST_MULTIARCH instead of ..._GNU_TYPE.
  * Replace d/runtests.sh with upstream testing/run_tests.py.
  * Add missing sources to fix the "codegen.py not found" issue.
  * Make libmagma-*test packages Depends on python3.

 -- Mo Zhou <lumin@debian.org>  Sun, 23 Feb 2025 11:44:28 -0500

magma (2.9.0+ds-1) unstable; urgency=medium

  * New upstream version 2.9.0+ds
  * Refresh existing patches.
  * d/rules: Update build flags to avoid no debugging symbol in debug files.
  * d/copyright: Remove superfluous file patterns.

 -- Mo Zhou <lumin@debian.org>  Sat, 08 Feb 2025 18:58:43 -0500
