## magma 2.9.0+ds

=== debian/changelog ===
magma (2.9.0+ds-3ubuntu1) resolute; urgency=medium

  * d/control.rocm: remove ppc64el builds for rocm.
    As per this bug #1122634 in debian, rocblas and hipblas removed from
    ppc64el builds. This is causing magma-rocm to be FTBFS, so removing
    ppc64el from magma-rocm as well.
  * d/rules: use GPU_TARGETS instead of deprecated AMDGPU_TARGETS
  * Patch magma to make it compatible with ROCm 7 (LP: #2142476)
    - d/p/0014-test-hipblas-also-some-cleanup.patch: required for ROCm 7 patches
    - d/p/0015-use-HIPBLAS_V2-types-and-APIs-ROCm-7-ready.patch
    - d/p/0016-allow-backward-compatibility-with-older-ROCm-hipblas.patch
    - d/p/0017-add-DHIPBLAS_V2-to-CMakeLists.txt.patch
    - d/p/0018-regenerate-interface_hip-and-magmablas_hip-files.patch

 -- Talha Can Havadar <talha.can.havadar@canonical.com>  Fri, 27 Feb 2026 09:09:27 +0100

magma (2.9.0+ds-3) unstable; urgency=medium

  * Team upload.

  [ Mo Zhou ]
  * [CUDA] Set GPU targets as "sm_50 sm_60 sm_70 sm_75 sm_80 sm_86 sm_90".

  [ Cordell Bloor ]
  * [ROCm] Use rocm-target-arch to select and document AMD GPU targets
  * [ROCm] Update my email address and copyright information
  * [ROCm] Add d/p/cmake4-compat.patch to fix FTBFS with CMake 4.0
  * [ROCm] Add d/p/no-rocm-core-tarball.patch to fix FTBFS with hipblas 2.0
  * [CUDA] Add d/p/undef-min-and-max.patch to fix FTBFS with CUDA 12.4.5.8
    (Closes: #1120236)

 -- Cordell Bloor <cgmb@debian.org>  Thu, 20 Nov 2025 19:24:11 -0700
