=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/science-team/magma.git
 Vcs-Browser: https://salsa.debian.org/science-team/magma
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13),
                gfortran,
